/* Code for GAMEPLAY.C */

#include "../include/robots.h"
#include "../include/util.h"
#include "../include/graphics.h"
#include <stdio.h>
#include <time.h>
#include <string.h>

void action(GtkWidget *w,gpointer data)
{
	int movable = *((int*)data);
	pair new=player,db;
	error=NULL;
	FLAG=0;
#ifdef DEBUG
g_print("click= %d",movable);
#endif
	switch(movable)
	{
		case SAMEPOINT :break;
		case NORTH :	new.r--;
			   	break;
		case SOUTH :	new.r++;
			   	break;
		case EAST :	new.c++;
				break;
		case WEST :	new.c--;
				break;
		case NORTHWEST :new.r--;
				new.c--;
				break;
		case SOUTHWEST :new.r++;
				new.c--;
				break;
		case SOUTHEAST :new.r++;
				new.c++;
				break;
		case NORTHEAST :new.r--;
				new.c++;
				break;
		case TELEPORT :	telemove();
				break;
	}
#ifdef DEBUG
	g_print("\nplayer: %d %d new: %d %d",player.r,player.c,new.r,new.c);
#endif
	if(new.r>=BOARDSIZE || new.c>=BOARDSIZE || new.r<0 || new.c<0)
		error="You cannot get out of the board.";
	else if(movable!=TELEPORT)
	{
		switch(board[new.r][new.c].code)
		{
			case EMPTY:move(player,new);
				   empty(player);
				   player=new;	   
				   break;
			case PLAYER:break;
			case ROBOT:error="You cannot walk into a robot.";
				   break;
			case DEBRIS:db.r = 2*new.r-player.r;
				    db.c = 2*new.c-player.c;
				    if(db.r>=BOARDSIZE || db.c>=BOARDSIZE || db.r<0 || db.c<0)
				    {
					error="You cannot push the debris out of the board.";
					break;
				    }
				    switch(board[db.r][db.c].code)
				    {
					case EMPTY:move(new,db);
						   move(player,new);
						   empty(player);
						   player=new;
						   break;
					case DEBRIS:error="Debris cannot be pushed into debris.";
						    break;
					case ROBOT:destroy(db);
						   move(player,new);
						   empty(player);
						   player=new;
						   robcount--;
						   break;
				    }
				    break;
		}
		moves++;
	}
	if(error==NULL)
	{
		if(moverobots())
			FLAG=1;
		updatetp();
	}
	gtk_statusbar_pop(GTK_STATUSBAR(statusbar),sbcid);
	if(error!=NULL)	
		gtk_statusbar_push(GTK_STATUSBAR(statusbar),sbcid,error);
	sprintf(tlstr,"Available Teleports : %d",avaltp);
	gtk_label_set_text(GTK_LABEL(tlabel),tlstr);
	sprintf(rlstr,"No. of Robots : %d",robcount);
	gtk_label_set_text(GTK_LABEL(rlabel),rlstr);
	if(FLAG)
		statistics();
}
				
void initgraph()
{
	GtkWidget *b,*img;
	int i,j;
	char s[20]="images/x.bmp";
#ifdef DEBUG
	g_print("\ninitgraph called");
#endif
	table = gtk_table_new(BOARDSIZE,BOARDSIZE,TRUE);
	for(i=0;i<BOARDSIZE;i++)
	{
		for(j=0;j<BOARDSIZE;j++)
		{
			switch(board[i][j].code)
			{
				case EMPTY:	b = gtk_image_new_from_file("images/eimage.bmp");
					   	break;
				case ROBOT:	b = gtk_image_new_from_file("images/rimage.bmp");
					   	break;
				case PLAYER:	b = gtk_image_new_from_file("images/pimage.bmp");
						break;
			}
			boardboxes[i][j]=b;
			gtk_table_attach_defaults(GTK_TABLE(table),b,j,j+1,i,i+1);
			gtk_widget_show(b);
		}
	}
	gtk_widget_show(table);
	updatetp();
	panel = gtk_table_new(3,3,TRUE);
	gtk_table_set_row_spacings(GTK_TABLE(panel),1);
	gtk_table_set_col_spacings(GTK_TABLE(panel),1);
	
	for(i=0;i<3;i++)
	{
		for(j=0;j<3;j++)
		{
			b = gtk_button_new();
			g_signal_connect(G_OBJECT(b),"clicked",G_CALLBACK(action),(gpointer)(buttonpanel+3*i+j));
			s[7]=3*i+j+49;
			img = gtk_image_new_from_file(s);
			gtk_container_add(GTK_CONTAINER(b),img);
			gtk_widget_show(img);
			gtk_table_attach(GTK_TABLE(panel),b,j,j+1,i,i+1,GTK_EXPAND,GTK_EXPAND,0,0);
			gtk_widget_show(b);
#ifdef DEBUG
			g_print("\npanel button %d created",3*i+j);
#endif
		}
	}
	controls = gtk_vbox_new(FALSE,0);
	reset = gtk_button_new_with_label("Restart");
	g_signal_connect(G_OBJECT(reset),"clicked",G_CALLBACK(restart),NULL);
	tele = gtk_button_new_with_label("Teleport");
	g_signal_connect(G_OBJECT(tele),"clicked",G_CALLBACK(action),(gpointer)(buttonpanel+9));
	gtk_widget_show(reset);
	gtk_widget_show(tele);
#ifdef DEBUG
	g_print("\nReset and teleport buttons created");
#endif
	sprintf(tlstr,"Available Teleports : %d",avaltp);
	tlabel = gtk_label_new(tlstr);
	gtk_label_set_justify(GTK_LABEL(tlabel),GTK_JUSTIFY_LEFT);
	gtk_box_pack_start(GTK_BOX(controls),tlabel,TRUE,FALSE,0);
	gtk_widget_show(tlabel);

	sprintf(rlstr,"No. of Robots : %d",robcount);
	rlabel = gtk_label_new(rlstr);
	gtk_label_set_justify(GTK_LABEL(rlabel),GTK_JUSTIFY_LEFT);
	gtk_box_pack_start(GTK_BOX(controls),rlabel,TRUE,FALSE,0);
	gtk_widget_show(rlabel);
	
	gtk_box_pack_start(GTK_BOX(controls),reset,TRUE,FALSE,0);

#ifndef __TELEPORT
	entry = gtk_entry_new();
	gtk_entry_set_max_length(GTK_ENTRY(entry),2);
	gtk_widget_set_size_request(GTK_WIDGET(entry),25,20);
	g_signal_connect(G_OBJECT(entry),"activate",G_CALLBACK(action),(gpointer)(buttonpanel+9));
	gtk_box_pack_start(GTK_BOX(controls),entry,TRUE,FALSE,0);
	gtk_widget_show(entry);
#endif
	gtk_box_pack_start(GTK_BOX(controls),tele,TRUE,FALSE,0);
	gtk_box_pack_start(GTK_BOX(controls),panel,TRUE,FALSE,0);
	gtk_widget_show(panel);
	gtk_widget_show(controls);
	statusbar = gtk_statusbar_new();
	sbcid=gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar),"Status Area");
	gtk_widget_show(statusbar);
	gtk_statusbar_push(GTK_STATUSBAR(statusbar),sbcid,"Use the button panel on the right to move.");
}
	
void gameplay()
{
	GtkWidget *box1,*box2;
#ifdef DEBUG
	g_print("\ngameplay called");
#endif
	gtk_widget_destroy(window);
#ifdef DEBUG
	g_print("\nwindow destroyed");
#endif
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_resizable(GTK_WINDOW(window),FALSE);
	gtk_window_set_title(GTK_WINDOW(window),"i-ROBOT");
	gtk_window_set_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);
	g_signal_connect(G_OBJECT(window),"delete_event",G_CALLBACK(myexit),NULL);
	gtk_container_set_border_width(GTK_CONTAINER(window),10);
	box1 = gtk_hbox_new(FALSE,0);
	box2 = gtk_vbox_new(FALSE,0);
	gtk_container_add(GTK_CONTAINER(window),box2);
	initgraph();
	gtk_box_pack_start(GTK_BOX(box1),table,TRUE,FALSE,20);
	gtk_box_pack_start(GTK_BOX(box1),controls,TRUE,FALSE,20);
	gtk_widget_show(box1);
	gtk_box_pack_start(GTK_BOX(box2),box1,TRUE,FALSE,10);
	gtk_box_pack_start(GTK_BOX(box2),statusbar,TRUE,FALSE,0);
	gtk_widget_show(box2);
	gtk_widget_show(window);
}
	
