/* Code for LOAD.C */

#include "../include/robots.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

int len(char *s)
{
	int i;
	for(i=0;s[i]!='\n';i++);
	return i;
}

int parseint(char *str,int *x,int *y)
{
	char s[4],c;
	int j,i=0;
	if(str==NULL || x==NULL || y==NULL)
	{
		return 0;
	}
	c=str[0];
	*x=*y=-1;
	while(c!='\n')
        {
                if(isdigit(c))
                {
                        j=0;
                        while(isdigit(c))
                        {
                                s[j++]=c;
                                c=str[++i];
                        }
			s[j]='\0';
			if(*x<0)
				*x=atoi(s);
			else
			{
				*y=atoi(s);
				break;
			}
		}
		else if(c!=' ')
			return 0;
		c=str[++i];
	}

#ifdef DEBUG
	g_print("\n Parsed %d %d",*x,*y);
#endif 
	return 1;
}

int load(const char *file)
{
	FILE *fp;
	char buffer[30];
	int r,c,i;
	pnode *ptr;
	
	fp=fopen(file,"rt");
	if(fp==NULL)
	{
		error="File not found.";
		return 0;
	}
	fgets(buffer,10,fp);
#ifdef DEBUG
	for(i=0;i<10;i++)
		g_print("%c",buffer[i]);
	g_print("\nend");
#endif
	if(len(buffer)>6)
	{
		error="Invalid file.";
		return 0;
	}

	if(!parseint(buffer,&R,&T))
	{
		error="Invalid file.";
		return 0;
	}
	if(R>MAXROBOTS || T>MAXTPORTS)
	{
		error="Invalid no. of robots/teleports.";
		return 0;
	}
#ifdef DEBUG
	g_print("R=%d T= %d",R,T);
#endif
	i=0;
	while(i<R)
	{
		fgets(buffer,10,fp);
		if(len(buffer)>5)
		{
			error="Invalid file.";
			return 0;
		}
		if(!parseint(buffer,&r,&c))
		{
			error="Invalid file.";
			return 0;
		}
		if(r>=BOARDSIZE || c>=BOARDSIZE)
		{
			error="Invalid positions.";
			return 0;
		}
		if(board[r][c].code!=EMPTY)
		{
			error="Two robots at same place.";
			return 0;
		}
		board[r][c].code=ROBOT;
		if(!i)
		{
			if((robot_list = (pnode*)malloc(sizeof(pnode)))==NULL)
			{
				error="Memory Allocation failed.";
				return 0;
			}	
			robot_list->p.r=r;
			robot_list->p.c=c;
			robot_list->next=robot_list->prev=NULL;
			ptr=robot_list;
		}
		else
		{
			if((ptr->next = (pnode*)malloc(sizeof(pnode)))==NULL)
			{
				error="Memory Allocation failed.";
				return 0;
			}	
			ptr->next->prev=ptr;
			ptr=ptr->next;
			ptr->p.r=r;
			ptr->p.c=c;
			ptr->next=NULL;
		}
		board[r][c].ptr=ptr;
		i++;
	}
	robcount=R;
#ifdef DEBUG
	g_print("\nRobots Initialised");
#endif
	i=0;
	while(i<T)
	{
		fgets(buffer,10,fp);
                if(len(buffer)>5)
                {
                        error="Invalid file.";
                        return 0;
                }
                if(!parseint(buffer,&r,&c))
                {
                        error="Invalid file.";
                        return 0;
                }
                if(r>=BOARDSIZE || c>=BOARDSIZE)
                {
                        error="Invalid positions.";
                        return 0;
                }
		if(board[r][c].code>=TELEPORT)
		{
			error="Two teleports at the same place.";
			return 0;
		}
		board[r][c].code+=TELEPORT;
#ifdef __TELEPORT
		if(!i)
		{
			if((teleports = (pnode*)malloc(sizeof(pnode)))==NULL)
			{
				error="Memory Allocation failed.";
				return 0;
			}	
			teleports->p.r=r;
			teleports->p.c=c;
			teleports->next=teleports->prev=NULL;
			ptr=teleports;
		}
		else
		{
			if((ptr->next = (pnode*)malloc(sizeof(pnode)))==NULL)
			{
				error="Memory Allocation failed.";
				return 0;
			}	
			ptr->next->prev=ptr;
			ptr=ptr->next;
			ptr->p.r=r;
			ptr->p.c=c;
			ptr->next=NULL;
		}
#else
		teleports[i].r=r;
		teleports[i].c=c;
#endif
		i++;
	}
	fclose(fp);
#ifdef DEBUG
	g_print("\nFile closed");
#endif
#ifdef __TELEPORT
	ptr=teleports;
	while(ptr!=NULL)
	{
		board[ptr->p.r][ptr->p.c].code-=TELEPORT;
		ptr=ptr->next;
	}
#else
	for(i=0;i<T;i++)
	{
		board[teleports[i].r][teleports[i].c].code-=TELEPORT;
	}
#endif

#ifdef DEBUG
	for(r=0;r<BOARDSIZE;r++)
	{
		g_print("\n");
		for(c=0;c<BOARDSIZE;c++)
		{
			g_print("%d ",board[r][c].code);
		}
	}
#endif
	updatetp();
#ifdef DEBUG
	g_print("\nFile loaded");
#endif 
	return 1;
}

int randinit()
{
	int r,c,i;
	pnode *ptr;
	R = rand()%MAXROBOTS + 1;
	T = rand()%MAXTPORTS + 1;
#ifdef DEBUG
	g_print("\nR=%d T=%d",R,T);
#endif 
	i=0;
	while(i<R)
	{
		r = rand()%BOARDSIZE;
		c = rand()%BOARDSIZE;
		if(board[r][c].code!=EMPTY)
                	continue;
#ifdef DEBUG
	g_print("\nrobot@ %d %d",r,c);
#endif
		board[r][c].code=ROBOT;
		if(!i)
                {
                        if((robot_list = (pnode*)malloc(sizeof(pnode)))==NULL)
			{
				error="Memory Allocation failed.";
				return 0;
			}	
                        robot_list->p.r=r;
                        robot_list->p.c=c;
                        robot_list->next=robot_list->prev=NULL;
                        ptr=robot_list;
                }
                else
                {
                        if((ptr->next = (pnode*)malloc(sizeof(pnode)))==NULL)
			{
				error="Memory Allocation failed.";
				return 0;
			}	
                        ptr->next->prev=ptr;
                        ptr=ptr->next;
                        ptr->p.r=r;
                        ptr->p.c=c;
                        ptr->next=NULL;
                }
                board[r][c].ptr=ptr;
                i++;
	}
	robcount=R;
	i=0;
	while(i<T)
	{
		r = rand()%BOARDSIZE;
		c = rand()%BOARDSIZE;
		if(board[r][c].code>=TELEPORT)
                        continue;
#ifdef DEBUG
	g_print("\nTeleport@ %d %d",r,c);
#endif
                board[r][c].code+=TELEPORT;
#ifdef __TELEPORT
                if(!i)
                {
                        if((teleports = (pnode*)malloc(sizeof(pnode)))==NULL)
			{
				error="Memory Allocation failed.";
				return 0;
			}	
                        teleports->p.r=r;
                        teleports->p.c=c;
                        teleports->next=teleports->prev=NULL;
                        ptr=teleports;
                }
                else
                {
                        if((ptr->next = (pnode*)malloc(sizeof(pnode)))==NULL)
			{
				error="Memory Allocation failed.";
				return 0;
			}	
                        ptr->next->prev=ptr;
                        ptr=ptr->next;
                        ptr->p.r=r;
                        ptr->p.c=c;
                        ptr->next=NULL;
                }
#else
                teleports[i].r=r;
                teleports[i].c=c;
#endif
	i++;
	}
	
#ifdef __TELEPORT
	ptr=teleports;
	while(ptr!=NULL)
	{
		board[ptr->p.r][ptr->p.c].code-=TELEPORT;
		ptr=ptr->next;
	}
#else
	for(i=0;i<T;i++)
	{
		board[teleports[i].r][teleports[i].c].code-=TELEPORT;
	}
#endif
	updatetp();
	return 1;
}

/* End of LOAD.C */
