/* Code for ROBOTS.C */

#include "../include/robots.h"
#include "../include/graphics.h"
#include "../include/util.h"

#include <malloc.h>
#include <stdlib.h>
#include <stdio.h>

void empty(pair p)
{
	GtkWidget *img;
#ifdef DEBUG
g_print("\nempty %d %d",p.r,p.c);
#endif
	board[p.r][p.c].code=EMPTY;
	board[p.r][p.c].ptr=NULL;
	gtk_widget_destroy(boardboxes[p.r][p.c]);
	img = gtk_image_new_from_file("images/eimage.bmp");
	boardboxes[p.r][p.c]=img;
	gtk_table_attach_defaults(GTK_TABLE(table),img,p.c,p.c+1,p.r,p.r+1);
	gtk_widget_show(img);
}
	
int moverobots()
{
	pnode *ptr=robot_list,*qpr;
	pair p;
	int a,b;
	while(ptr!=NULL)
	{
		p=ptr->p;
		if(ptr!=board[p.r][p.c].ptr)
			g_print("Runtime Exception");
		board[p.r][p.c].code=EMPTY;
		ptr=ptr->next;
	}
	ptr=robot_list;
	error=NULL;
	while(ptr!=NULL)
	{
		p = ptr->p;
		a = player.r - p.r;
		b = player.c - p.c;
		a = (a)?((a<0)?-1:1):0;
		b = (b)?((b<0)?-1:1):0;
		p.r+=a;
		p.c+=b;
	
		switch(board[p.r][p.c].code)
		{
			case PLAYER:error="Mighty you may be, but this is where you fall.";
			case EMPTY:if(board[ptr->p.r][ptr->p.c].code!=EMPTY)
				   {
					move(ptr->p,p);
					board[p.r][p.c].ptr=ptr;
				   }
				   else
				   {
					board[ptr->p.r][ptr->p.c].code=ROBOT;
					move(ptr->p,p);
					board[p.r][p.c].ptr=ptr;
					empty(ptr->p);
				   }
				   ptr->p=p;
				   ptr=ptr->next;
				   break;
			case ROBOT:if(board[ptr->p.r][ptr->p.c].code!=EMPTY)
				   {
					destroy(p);
					if(ptr==robot_list)
						robot_list=robot_list->next;
					if(ptr->next!=NULL)
						ptr->next->prev=ptr->prev;
					if(ptr->prev!=NULL)
						ptr->prev->next=ptr->next;
					qpr=ptr;
					ptr=ptr->next;
					free(qpr);
				   }
				   else
				   {
					destroy(p);
				   	qpr=ptr;
				   	ptr=ptr->next;
					p=qpr->p;
					destroy(qpr->p);
				   	empty(p);
				   }
				   robcount-=2;	
				   break;
			case DEBRIS:if(board[ptr->p.r][ptr->p.c].code==EMPTY)
				    {
					qpr=ptr;
				    	ptr=ptr->next;
				    	p=qpr->p;
					destroy(qpr->p);
				  	empty(p);
				    }
				    else
				    {
					if(ptr==robot_list)
						robot_list=robot_list->next;
					if(ptr->next!=NULL)
						ptr->next->prev=ptr->prev;
					if(ptr->prev!=NULL)
						ptr->prev->next=ptr->next;
					qpr=ptr;
					ptr=ptr->next;
					free(qpr);
				    }
				    robcount--;
				    break;
		}
	}
#ifdef DEBUG
ptr=robot_list;
while(ptr!=NULL)
{
	g_print("\nRobot %d %d",ptr->p.r,ptr->p.c);
	ptr=ptr->next;
}
for(a=0;a<BOARDSIZE;a++)
{
	g_print("\n");
	for(b=0;b<BOARDSIZE;b++)
	{
		g_print("%d ",board[a][b].code);
	}
}
#endif
	if(error!=NULL)
	{
		return 1;
	}
	if(robcount==0)
	{
		FLAG=-1;
		error = "Victory lies at thy feet !";
	}
	return 0;
}	

void move(pair p1,pair p2)
{
	int r,c;
	GtkWidget *img;
	board[p2.r][p2.c]=board[p1.r][p1.c];
	r=p2.r;
	c=p2.c;
	gtk_widget_destroy(boardboxes[r][c]);
	switch(board[r][c].code)
	{
		case EMPTY :img = gtk_image_new_from_file("images/eimage.bmp");
			    break;
		case ROBOT :img = gtk_image_new_from_file("images/rimage.bmp");
			    break;
		case PLAYER:img = gtk_image_new_from_file("images/pimage.bmp");
			    break;
		case DEBRIS:img = gtk_image_new_from_file("images/dimage.bmp");
			    break;
	}
	gtk_table_attach_defaults(GTK_TABLE(table),img,c,c+1,r,r+1);
	boardboxes[r][c]=img;
	gtk_widget_show(img);
}

void telemove()
{
#ifdef __TELEPORT
	pnode *ptr;
#else
	const char *s;
	int i;
#endif	
	pair p;
	if(!avaltp)
	{
		error="No teleport locations available.";
		return;
	}
#ifdef __TELEPORT
	ptr=teleports;
	while(ptr!=NULL)
	{
		p = ptr->p;
		if(board[p.r][p.c].code==EMPTY)
		{
			move(player,p);
			empty(player);
			player=p;
			if(ptr==teleports)
				teleports=teleports->next;
			if(ptr->next!=NULL)
				ptr->next->prev=ptr->prev;
			if(ptr->prev!=NULL)
				ptr->prev->next=ptr->next;
			free(ptr);
			tpmoves++;
			return;
		}
		ptr=ptr->next;
	}
#else
	s = gtk_entry_get_text(GTK_ENTRY(entry));
	i = atoi(s);
	if(!i || i>T)
	{
		error="Invalid teleport location.";
		return;
	}
	i--;
	p = teleports[i];
	if(board[p.r][p.c].code==EMPTY)
	{
		move(player,p);
		empty(player);
		player=p;
		p.r=-1;
		p.c=-1;
		teleports[i]=p;
		tpmoves++;
		return;
	}
	error="Teleport location is not empty";
#endif
}

void destroy(pair p)
{
	pnode *ptr = board[p.r][p.c].ptr;
	GtkWidget *img = gtk_image_new_from_file("images/dimage.bmp");
	gtk_widget_destroy(boardboxes[p.r][p.c]);
	boardboxes[p.r][p.c]=img;
	gtk_table_attach_defaults(GTK_TABLE(table),img,p.c,p.c+1,p.r,p.r+1);
	gtk_widget_show(img);
	if(ptr==robot_list)
		robot_list=robot_list->next;
	if(ptr->next!=NULL)
		ptr->next->prev=ptr->prev;
	if(ptr->prev!=NULL)
		ptr->prev->next=ptr->next;
	free(ptr);
	board[p.r][p.c].code=DEBRIS;
	board[p.r][p.c].ptr=NULL;
}

void updatetp()
{
#ifdef __TELEPORT
	pnode *ptr = teleports;
#else
	int i=0;
	char s[4];
	GtkWidget *tpnum;
#endif
	pair p;
	avaltp=0;
#ifdef __TELEPORT
	while(ptr!=NULL)
	{
		p=ptr->p;
		if(board[p.r][p.c].code==EMPTY)
			avaltp++;
		ptr=ptr->next;
	}
#else
	for(i=0;i<T;i++)
	{
		p=teleports[i];
		if(p.r<0 || p.c<0)
			continue;
#ifdef DEBUG
	g_print("%d %d\n",p.r,p.c);
#endif
		if(board[p.r][p.c].code==EMPTY)
		{
			avaltp++;
			if(table==NULL)
				continue;
			sprintf(s,"%d",i+1);
			tpnum=gtk_label_new(s);
			gtk_widget_destroy(boardboxes[p.r][p.c]);
			boardboxes[p.r][p.c]=tpnum;
			gtk_table_attach_defaults(GTK_TABLE(table),tpnum,p.c,p.c+1,p.r,p.r+1);
			gtk_widget_show(tpnum);
		}
	}
#endif
#ifdef DEBUG
	g_print("\n avaltp = %d",avaltp);
#endif
}

/* End of ROBOTS.C */
	
	
